﻿Imports System.Configuration
Imports System.Net.Http

Public Class UserHttpClient
    Inherits LuxApiHttpClient

    Public Sub New()
        MyBase.New()
        requestPath = ConfigurationManager.AppSettings("UserPath")
    End Sub

    'Get User profile
    Public Async Function GetUserProfile(ByVal path As String, ByVal authenticationCode As String, ByVal hmacSignature As String) As Task(Of LuxSciResponse)
        requestPath = path
        GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature))
        Return Await GetDataAsync()
    End Function

    'Send mail
    Public Async Function SendMail(ByVal path As String, ByVal authenticationCode As String, ByVal hmacSignature As String, ByVal emailRequest As EmailRequest) As Task(Of LuxSciResponse)
        requestPath = path
        GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature))
        Return Await PostAsJsonAsync(emailRequest)
    End Function

    'Send mail with Attachment
    Public Async Function SendMailWithAttachment(ByVal path As String, ByVal authenticationCode As String, ByVal hmacSignature As String, ByVal request As HttpRequestMessage, ByVal boundary As String) As Task(Of LuxSciResponse)
        requestPath = path
        GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature))
        client.Timeout = TimeSpan.FromMilliseconds(300000)
        client.DefaultRequestHeaders.TryAddWithoutValidation("Content-Type", "multipart/form-data; boundary=" & boundary)
        Return Await SendAsync(request)
    End Function

    'Get email sent report
    Public Async Function GetEmailSentReport(ByVal path As String, ByVal authenticationCode As String, ByVal hmacSignature As String) As Task(Of LuxSciResponse)
        requestPath = path
        GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature))
        Return Await GetDataAsync()
    End Function
End Class
